package de.mathema.spring.gui;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.AbstractListModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JList;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import de.mathema.spring.api.Subscriber;
import de.mathema.spring.api.Subscription;

public class GuiClient extends JFrame implements ActionListener{
	JList list = null;
	private Subscription subscription;
	/**
	 * @param args
	 */
	public GuiClient(){
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		list = new JList();
		getContentPane().add(list);
		JButton button = new JButton("List all");
		button.addActionListener(this);
		getContentPane().add(button, BorderLayout.SOUTH);
		ApplicationContext context = new ClassPathXmlApplicationContext("SpringConfigRemote.xml");
		subscription = (Subscription) context.getBean(Subscription.class.getName());
		this.setSize(400, 400);
    	this.setVisible(true);
	}
	
	public static void main(String[] args) {
		new GuiClient();
	}
	@Override
	public void actionPerformed(ActionEvent e) {
		final List<Subscriber> all = subscription.listAll(false);
		list.setModel(new AbstractListModel(){

			@Override
			public Object getElementAt(int arg0) {
				Subscriber s = all.get(arg0); 
				String st = s.getNickName() + ":" + s.getEmail() + ":" + s.isConfirmed();				
				return st;
			}

			@Override
			public int getSize() {
				return all.size();
			}
			
		});
	}

}
